import { IDecoratedAsset } from "../types/asset";
import { TrackOptions } from "./TrackOptions";
export declare class AssetEnvelope {
    asset: IDecoratedAsset;
    assetId: number;
    minDuration: number;
    maxDuration: number;
    duration: number;
    start: number;
    fadeInDuration: number;
    fadeOutDuration: number;
    startFadingOutSecs: number;
    constructor(trackOptions: TrackOptions, asset: IDecoratedAsset);
    toString(): string;
}
