import { ApiClient } from "./api-client";
import { IAssetData, IAssetFilters } from "./types/asset";
export declare const PATH = "/assets/";
export declare class Asset {
    private _projectId;
    private _apiClient;
    constructor(projectId: number, options: {
        apiClient: ApiClient;
    });
    connect(data?: IAssetFilters): Promise<IAssetData[]>;
}
