/// <reference types="node" />
import { IAudioContext, IStereoPannerNode } from "standardized-audio-context";
export declare class AudioPanner {
    minpanpos: number;
    maxpanpos: number;
    minpanduration: number;
    maxpanduration: number;
    panPositionChangePerSecond?: number;
    finalPosition?: number;
    initialPosition?: number;
    duration?: number;
    currentPosition?: number;
    panningTowards?: string;
    timerId?: NodeJS.Timeout;
    panNode: IStereoPannerNode<IAudioContext>;
    audioContext: IAudioContext;
    constructor(minpanpos: number | undefined, maxpanpos: number | undefined, minpanduration: number | undefined, maxpanduration: number | undefined, panNode: IStereoPannerNode<IAudioContext>, audioContext: IAudioContext);
    updateParams(): void;
    start(): void;
    clear(): void;
}
