export declare class RoundwareFrameworkError extends Error {
    constructor(message: string, ...args: any);
}
export declare class MissingArgumentError extends RoundwareFrameworkError {
    constructor(argumentName: string, whileDescription: string, expectedType: string, ...args: any);
}
export declare class InvalidArgumentError extends RoundwareFrameworkError {
    constructor(argumentName: string, expected: string, whileDescription: string, ...args: any);
}
export declare class RoundwareConnectionError extends RoundwareFrameworkError {
    constructor(additonalContext?: string, ...args: any);
}
