"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.reflect.construct.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.map.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RoundwareFrameworkError = exports.RoundwareConnectionError = exports.MissingArgumentError = exports.InvalidArgumentError = void 0;

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.object.get-prototype-of.js");

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct.bind(); } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var RoundwareFrameworkError = /*#__PURE__*/function (_Error) {
  _inherits(RoundwareFrameworkError, _Error);

  var _super = _createSuper(RoundwareFrameworkError);

  function RoundwareFrameworkError(message) {
    var _this;

    _classCallCheck(this, RoundwareFrameworkError);

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.message = message;
    return _this;
  }

  return _createClass(RoundwareFrameworkError);
}( /*#__PURE__*/_wrapNativeSuper(Error));

exports.RoundwareFrameworkError = RoundwareFrameworkError;

var MissingArgumentError = /*#__PURE__*/function (_RoundwareFrameworkEr) {
  _inherits(MissingArgumentError, _RoundwareFrameworkEr);

  var _super2 = _createSuper(MissingArgumentError);

  function MissingArgumentError(argumentName, whileDescription, expectedType) {
    _classCallCheck(this, MissingArgumentError);

    for (var _len2 = arguments.length, args = new Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
      args[_key2 - 3] = arguments[_key2];
    }

    return _super2.call.apply(_super2, [this, "Expected argument \"".concat(argumentName, "\" was missing or invalid while ").concat(whileDescription, ". Please pass ").concat(argumentName, " of type \"").concat(expectedType, "\" while ").concat(whileDescription)].concat(args));
  }

  return _createClass(MissingArgumentError);
}(RoundwareFrameworkError);

exports.MissingArgumentError = MissingArgumentError;

var InvalidArgumentError = /*#__PURE__*/function (_RoundwareFrameworkEr2) {
  _inherits(InvalidArgumentError, _RoundwareFrameworkEr2);

  var _super3 = _createSuper(InvalidArgumentError);

  function InvalidArgumentError(argumentName, expected, whileDescription) {
    _classCallCheck(this, InvalidArgumentError);

    for (var _len3 = arguments.length, args = new Array(_len3 > 3 ? _len3 - 3 : 0), _key3 = 3; _key3 < _len3; _key3++) {
      args[_key3 - 3] = arguments[_key3];
    }

    return _super3.call.apply(_super3, [this, "Expected argument \"".concat(argumentName, "\" to be \"").concat(expected, "\" while ").concat(whileDescription)].concat(args));
  }

  return _createClass(InvalidArgumentError);
}(RoundwareFrameworkError);

exports.InvalidArgumentError = InvalidArgumentError;

var RoundwareConnectionError = /*#__PURE__*/function (_RoundwareFrameworkEr3) {
  _inherits(RoundwareConnectionError, _RoundwareFrameworkEr3);

  var _super4 = _createSuper(RoundwareConnectionError);

  function RoundwareConnectionError(additonalContext) {
    _classCallCheck(this, RoundwareConnectionError);

    for (var _len4 = arguments.length, args = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
      args[_key4 - 1] = arguments[_key4];
    }

    return _super4.call.apply(_super4, [this, "".concat(additonalContext ? additonalContext + " " : "", "Sorry, we were unable to connect to Roundware. Please try again.")].concat(args));
  }

  return _createClass(RoundwareConnectionError);
}(RoundwareFrameworkError);

exports.RoundwareConnectionError = RoundwareConnectionError;