"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.symbol.async-iterator.js");

require("core-js/modules/es.symbol.to-string-tag.js");

require("core-js/modules/es.json.to-string-tag.js");

require("core-js/modules/es.math.to-string-tag.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.array.slice.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SpeakerPrefetchPlayer = void 0;

require("core-js/modules/es.number.constructor.js");

require("core-js/modules/es.number.to-fixed.js");

require("core-js/modules/es.array.concat.js");

var _utils = require("../utils");

function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return generator._invoke = function (innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; }(innerFn, self, context), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; this._invoke = function (method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); }; } function maybeInvokeDelegate(delegate, context) { var method = delegate.iterator[context.method]; if (undefined === method) { if (context.delegate = null, "throw" === context.method) { if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel; context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method"); } return ContinueSentinel; } var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (object) { var keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, catch: function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SpeakerPrefetchPlayer = /*#__PURE__*/function () {
  function SpeakerPrefetchPlayer(_ref) {
    var _this = this;

    var audioContext = _ref.audioContext,
        id = _ref.id,
        uri = _ref.uri,
        config = _ref.config;

    _classCallCheck(this, SpeakerPrefetchPlayer);

    _defineProperty(this, "isSafeToPlay", true);

    _defineProperty(this, "playing", false);

    _defineProperty(this, "loaded", false);

    _defineProperty(this, "loadedPercentage", 0);

    _defineProperty(this, "started", false);

    _defineProperty(this, "startedAt", 0);

    _defineProperty(this, "pausedAt", 0);

    _defineProperty(this, "endTimeout", null);

    _defineProperty(this, "_fadingDestination", 0);

    _defineProperty(this, "_fading", false);

    _defineProperty(this, "_fadingTimeout", null);

    _defineProperty(this, "loadingCallback", function (number) {});

    _defineProperty(this, "endCallback", function () {});

    this.audio = new Audio();
    this.id = id;
    this.context = audioContext;
    this.config = config;
    this.gainNode = audioContext.createGain();
    this.gainNode.gain.value = _utils.NEARLY_ZERO;
    var request = new XMLHttpRequest();
    request.open("GET", uri, true);
    request.timeout = Infinity;
    request.responseType = "arraybuffer";

    request.onprogress = function (ev) {
      _this.loadedPercentage = Number((ev.loaded / ev.total * 100).toFixed(2));

      _this.loadingCallback(_this.loadedPercentage);
    };

    var speakerContext = this;

    request.onload = function () {
      var audioData = request.response;
      audioContext.decodeAudioData(audioData, function (buffer) {
        speakerContext.buffer = buffer; // @ts-ignore

        global._roundwareTotalAudioBufferSize += buffer.length * buffer.numberOfChannels * 4;
        speakerContext.loaded = true;
        speakerContext.log("loaded successfully");
      }, function (e) {
        speakerContext.log("Error with decoding audio data " + e.message);
      });
    };

    request.send();
  }

  _createClass(SpeakerPrefetchPlayer, [{
    key: "play",
    value: function () {
      var _play = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(!this.loaded || !this.started)) {
                  _context.next = 3;
                  break;
                }

                this.log("not loaded or started yet");
                return _context.abrupt("return", false);

              case 3:
                if (!this.playing) {
                  _context.next = 6;
                  break;
                }

                this.fade();
                return _context.abrupt("return", true);

              case 6:
                this.gainNode.connect(this.context.destination);
                this.playing = true;
                return _context.abrupt("return", true);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function play() {
        return _play.apply(this, arguments);
      }

      return play;
    }()
  }, {
    key: "replay",
    value: function replay() {
      this.pausedAt = 0;
      this.playing = false;
      this.initializeSource();
      this.timerStart();
    }
  }, {
    key: "remainingDuration",
    get: function get() {
      var _this$buffer;

      if (!this.buffer) return 0;
      return (this.config.length || ((_this$buffer = this.buffer) === null || _this$buffer === void 0 ? void 0 : _this$buffer.duration)) - this.pausedAt;
    }
  }, {
    key: "timerStart",
    value: function () {
      var _timerStart = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
        var _this2 = this;

        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(this.started || !this.buffer)) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return");

              case 2:
                // see timerStop() note
                this.initializeSource();

                if (this.source) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return");

              case 5:
                if (!(this.context.state !== "running")) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 8;
                return this.context.resume();

              case 8:
                // start now will so stay in sync with other speakers, from last paused time
                this.source.start(this.context.currentTime, this.pausedAt);

                if (this.endTimeout) {
                  clearTimeout(this.endTimeout);
                }

                this.endTimeout = setTimeout(function () {
                  _this2.endCallback();

                  _this2.log("speaker end");
                }, this.remainingDuration * 1000);
                this.fade();
                this.startedAt = this.context.currentTime;
                this.started = true;

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function timerStart() {
        return _timerStart.apply(this, arguments);
      }

      return timerStart;
    }()
  }, {
    key: "timerStop",
    value: function timerStop() {
      var _this$source;

      /**
       * note: we cant just stop the source and resume
       * start() and stop() are allow to called only once
       *
       * so need to
       * note the current time as paused time (incremented with previous paused times)
       * destroy current source
       * and next time needs to start, create new source
       * we can pass the already downloaded buffer
       * start with offset as last paused time
       */
      (_this$source = this.source) === null || _this$source === void 0 ? void 0 : _this$source.stop();
      this.pausedAt += this.context.currentTime - this.startedAt;
      this.log("next time will start from ".concat(this.pausedAt));
      this.source = undefined;
      this.started = false;

      if (this.endTimeout) {
        clearTimeout(this.endTimeout);
      }
    }
  }, {
    key: "initializeSource",
    value: function initializeSource() {
      var _this$source2;

      if (!this.buffer) return; // disconnect previous ones as we are going to create new

      this.gainNode.disconnect();
      (_this$source2 = this.source) === null || _this$source2 === void 0 ? void 0 : _this$source2.disconnect(); // create new source

      this.source = this.context.createBufferSource(); // buffer already downloaded from constructor

      this.source.buffer = this.buffer;

      if (this.config.loop) {
        this.source.loop = true;
        this.source.loopEnd = this.config.length || this.buffer.duration;
      } else {
        this.source.loop = false;
      } // connect to audio context


      this.source.connect(this.gainNode).connect(this.context.destination);
      this.started = false;
      console.log("init");
      this.fade();
    }
  }, {
    key: "pause",
    value: function pause() {
      if (!this.playing) return;
      this.gainNode.disconnect();
      this.playing = false;
    }
  }, {
    key: "fade",
    value: function fade() {
      var _this3 = this;

      var toVolume = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this._fadingDestination;
      var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3;
      if (this._fadingDestination == toVolume && this._fading) return;
      this._fadingDestination = toVolume;
      if (!this.playing) return; // already at that volume

      if (Math.abs(this.volume - this._fadingDestination) < 0.05) return;
      this.log("startng fade ".concat(this.volume, " -> ").concat(this._fadingDestination));
      this.gainNode.gain.cancelScheduledValues(0);
      this.gainNode.gain.exponentialRampToValueAtTime(this._fadingDestination || _utils.NEARLY_ZERO, this.context.currentTime + duration);

      if (this._fadingTimeout) {
        clearTimeout(this._fadingTimeout);
      }

      this._fadingTimeout = setTimeout(function () {
        _this3._fading = false;
      }, duration * 1000);
    }
  }, {
    key: "fadeOutAndPause",
    value: function fadeOutAndPause() {
      var _this4 = this;

      if (!this.playing) return;
      this.fade(0);
      this.log("fading out and pausing");
      setTimeout(function () {
        _this4.pause();
      }, 3000);
    }
  }, {
    key: "log",
    value: function log(string) {
      (0, _utils.speakerLog)("".concat(this.id, "] ").concat(string));
    }
  }, {
    key: "volume",
    get: function get() {
      return this.gainNode.gain.value;
    }
  }, {
    key: "onLoadingProgress",
    value: function onLoadingProgress(callback) {
      this.loadingCallback = callback;
    }
  }, {
    key: "onEnd",
    value: function onEnd(callback) {
      this.endCallback = callback;
      console.log("callback set");
    }
  }]);

  return SpeakerPrefetchPlayer;
}();

exports.SpeakerPrefetchPlayer = SpeakerPrefetchPlayer;